"use strict";
const metadata_1 = require("../../metadata");
require("reflect-metadata");
const pk_decorator_1 = require("./pk.decorator");
function Model(tableName) {
    var meta;
    if (typeof tableName === 'string')
        meta = { tableName: tableName };
    else
        meta = tableName || {};
    return function (model) {
        Reflect.defineMetadata(metadata_1.ModelMetadataSym, meta, model.prototype);
        let props = Reflect.getOwnMetadata(metadata_1.ModelPropertiesSym, model.prototype) || [];
        if (!props.find(propName => propName == 'id')) {
            pk_decorator_1.Pk()(model.prototype, 'id');
            props = Reflect.getOwnMetadata(metadata_1.ModelPropertiesSym, model.prototype);
        }
        Reflect.defineMetadata(metadata_1.ModelPropertiesSym, props, model.prototype);
    };
}
exports.Model = Model;
//# sourceMappingURL=model.decorator.js.map