"use strict";
const metadata_1 = require("../../metadata");
const sequelize = require("sequelize");
require("reflect-metadata");
function Prop(columnName) {
    let meta;
    if (typeof columnName === 'string')
        meta = { columnName: columnName };
    else
        meta = columnName || {};
    return function (model, propertyName) {
        var props = Reflect.getOwnMetadata(metadata_1.ModelPropertiesSym, model) || [];
        props.push(propertyName);
        Reflect.defineMetadata(metadata_1.ModelPropertiesSym, props, model);
        if (!meta.type) {
            var reflectType = Reflect.getMetadata('design:type', model, propertyName);
            var sequelizeType = null;
            if (reflectType === String)
                sequelizeType = sequelize.STRING;
            else if (reflectType === Number) {
                if (meta.primaryKey || meta.autoIncrement)
                    sequelizeType = sequelize.INTEGER;
                else
                    sequelizeType = sequelize.FLOAT;
            }
            else if (reflectType === Date)
                sequelizeType = sequelize.DATE;
            else if (reflectType === Boolean)
                sequelizeType = sequelize.BOOLEAN;
            else
                throw new Error(`Could not infer column type for model property: ${propertyName}`);
            meta.type = sequelizeType;
        }
        Reflect.defineMetadata(metadata_1.PropMetadataSym, meta, model, propertyName);
    };
}
exports.Prop = Prop;
//# sourceMappingURL=prop.decorator.js.map