/// <reference types="express" />
import * as express from 'express';
import { RouteMetadata, RouteMethod } from '../../../metadata';
import 'reflect-metadata';
export declare type RouteFunc = (req: express.Request, res: express.Response) => void | Promise<void>;
export declare type RouteFuncDescriptor = TypedPropertyDescriptor<RouteFunc>;
export declare type RouteDecoratorFunc = (target: Object, propertyKey: string, propertyDescriptor: RouteFuncDescriptor) => void;
export declare function createRouteDecorator(pathOrMeta: RouteMetadata | string, method?: RouteMethod): RouteDecoratorFunc;
export declare function Route(meta: RouteMetadata): RouteDecoratorFunc;
