"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const server_1 = require("./server");
class Miter {
    static launch(meta) {
        return __awaiter(this, void 0, void 0, function* () {
            let serverInst = new server_1.Server(meta);
            let initPromise = serverInst.init();
            process.on('SIGINT', () => __awaiter(this, void 0, void 0, function* () {
                serverInst.logger.error('miter', `Received SIGINT kill signal...`);
                try {
                    yield initPromise; //Wait for initialization before we try to shut down the server
                    yield serverInst.shutdown();
                }
                finally {
                    process.exit(serverInst.errorCode);
                }
            }));
            yield initPromise;
            return serverInst;
        });
    }
    static normalizePort(val) {
        var port = parseInt(val, 10);
        if (isNaN(port)) {
            // named pipe
            return val;
        }
        if (port >= 0) {
            // port number
            return port;
        }
        throw new Error(`Failed to normalize port: ${val}`);
    }
}
exports.Miter = Miter;
//# sourceMappingURL=miter.js.map